﻿@{
    ViewBag.Title = "Account Bank List";
    var ID = ViewBag.ID; 
}
<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Customer
        <small>Account Banks</small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="/"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="active">AccountBanks @ID</li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <div id="data-list" class="box">
        <div class="box-header with-border">
            <h3 class="box-title">Account Banks List</h3>
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                        title="Collapse">
                    <i class="fa fa-minus"></i>
                </button>
                <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                    <i class="fa fa-times"></i>
                </button>
            </div>
        </div>
        <div class="box-body">
            <div id="grid-accbank"></div>
        </div>
        <!-- /.box-body -->
        <div class="box-footer text-right">
            <button id="btn-add" type="button" class="btn btn-primary"><i class="fa fa-plus"></i> Add New</button>
        </div>
        <!-- /.box-footer-->
    </div>
    <!-- /.box -->
    <div id="data-detail" class="box" style="display: none">
        <form name="form1">
            <div class="box-header with-border">
                <h3 class="box-title">Bank Detail</h3>
                <div class="box-tools pull-right">
                    <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                            title="Collapse">
                        <i class="fa fa-minus"></i>
                    </button>
                    <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                        <i class="fa fa-times"></i>
                    </button>
                </div>
            </div>
            <div class="box-body">
                <div class="form-horizontal">
                    <div class="form-group">
                        <div class="col-md-2 control-label">Bank ID</div>
                        <div class="col-md-3">
                            <div class="input-group">
                                <input data-bind="BankID" type="text" name="BankID" class="form-control" readonly />
                                <div class="input-group-btn">
                                    <button id="btn-select-bank" type="button" class="btn btn-primary"><i class="fa fa-bank"></i></button>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-2 control-label">Account Number</div>
                        <div class="col-md-3">
                            <input data-bind="AccountNumber" type="text" name="AccountNumber" class="form-control text-right" />
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Branch</div>
                        <div class="col-md-3">
                            <input data-bind="Branch" type="text" name="Branch" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Create Date</div>
                        <div class="col-md-3">
                            <div class="input-group">
                                <input date-picker type="text" data-bind="CreateDate" name="CreateDate" class="form-control" required maxlength="15">
                                <div class="input-group-addon">
                                    <i class="fa fa-calendar"></i>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="box-footer text-center">
                <button id="btn-back" type="button" class="btn btn-default"><i class="fa fa-chevron-left"></i> Back</button>
                <button id="btn-save" type="button" class="btn btn-primary"><i class="fa fa-save"></i> Save</button>
            </div>
        </form>
    </div>
</section>
<!-- /.content-->
<div id="select-bank" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-body">
            <div class="box box-primary">
                <div class="box-header with-border">
                    Select Bank
                    <span class="close" style="color: white; opacity:1" data-dismiss="modal">&times;</span>
                </div>
                <div class="box-body">
                    <div id="grid-bank"></div>
                </div>
                <div class="box-footer text-center">
                    <button type="button" class="btn btn-default" data-dismiss="modal">
                        <i class="fa fa-remove"></i> Close
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>
@section Scripts{
    <script>
        (function () {

            function AccountBank() {
                return {
                    BankID: 0,
                    AccountID: '@ID',
                    AccountNumber: '',
                    Branch: '',
                    CreateDate: '',
                    ModifiedDate: null
                }
            }

            var scope = (function () {
                return Bind({
                    accbank: new AccountBank()
                }, {
                        "accbank.BankID": "[data-bind='BankID']",
                        "accbank.AccountNumber": "[data-bind='AccountNumber']",
                        "accbank.Branch": "[data-bind='Branch']",
                        "accbank.CreateDate": "[data-bind='CreateDate']"
                    });
            }());

            var state = "new";

            var gridAccount = gridview("grid-accbank", {
                url: "/TopUp/PagingByAccountID",
                columns: [
                    {
                        text: "", render: function (c) {
                            var tmpl = "<a action='view'><i class='fa fa-search'></i></a>";
                            tmpl += "<a action='edit'><i class='fa fa-edit'></i></a>";
                            tmpl += "<a action='remove'><i class='fa fa-trash'></i></a>";
                            return tmpl;
                        }
                    },
                    { field: "BankID", text: "Bank ID", sortable: true },
                    { field: "AccountNumber", text: "Account Number", sortable: true },
                    { field: "Branch", text: "Branch", sortable: true },
                    { field: "AccountID", text: "AccountID", sortable: true },
                    { field: "CreateDate", text: "Create Date", sortable: true }
                ],
                fieldKey: "BankID",
                view: view,
                edit: edit,
                remove: remove
            });

            var gridBank = gridview("grid-bank", {
                url: "/Bank/Paging",
                columns: [
                    {
                        text: "", render: function (c) {
                            var tmpl = "<a action='select'><i class='fa fa-check'></i></a>";
                            return tmpl;
                        }
                    },
                    { field: "BankID", text: "Bank ID", sortable: true },
                    { field: "BankName", text: "Bank Name", sortable: true },
                    { field: "HeadOffice", text: "Head Office", sortable: true },
                    { field: "ContactName", text: "Contact Name", sortable: true },
                    { field: "ContactPhone", text: "Contact Phone", sortable: true }
                ],
                fieldKey: "BankID",
                select: function (bnk) {
                    scope.accbank.BankID = bnk.BankID;
                    $("#select-bank").modal("hide");
                },
            });

            function addNew() {
                state = "new";
                scope.accbank = new AccountBank();
                showDetail();
                $("[data-bind]").attr("disabled", false);
                $("#btn-save").show();
            }

            function view(bnk) {
                console.log(bnk);
                scope.accbank = bnk;
                showDetail();
                $("[data-bind]").attr("disabled", true);
                $("#btn-save").hide();
            }

            function edit(bnk) {
                state = "update";
                scope.accbank = bnk;
                showDetail();
                $("[data-bind]").attr("disabled", false);
                $("[data-bind='BankID']").attr("disabled", true);
                $("#btn-save").show();
            }

            function remove(bnk) {
                Swal.fire({
                    title: "Confirmation",
                    text: "Are You Sure?",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonText: "YES",
                    cancelButtonText: "NO",
                    confirmButtonColor: "red"
                })
                    .then(function (r) {
                        if (r.value) {
                            axios.post("/AccountBank/Delete", { id: bnk.BankID })
                                .then(function (res) { return res.data; }, function (err) { console.log("Err: ", err) })
                                .then(function (res) {
                                    if (res.meta.success) {
                                        Swal.fire("Success", "Delete data success", "success")
                                            .then(function (r) {
                                                grid.reload();
                                            });
                                    } else {
                                        Swal.fire("Error", res.meta.message, "error");
                                    }
                                });
                        }
                    })
            }

            function showList() {
                $("#data-detail").fadeOut(250, function () { $("#data-list").fadeIn(500) });
            }

            function showDetail() {
                $("#data-list").fadeOut(250, function () { $("#data-detail").fadeIn(500) });
            }

            function save() {
                var url = "/AccountBank/" + (state === "new" ? "Insert" : "Update");
                
                axios.post(url, { accbank: scope.accbank })
                    .then(function (res) { return res.data; }, function (err) { console.log("Err: ", er); })
                    .then(function (res) {
                        if (res.meta.success) {
                            Swal.fire("Success", "Save data success", "success")
                                .then(function (r) {
                                    showList();
                                    gridAccount.reload();
                                });
                        } else {
                            Swal.fire("Error", res.meta.message, "error");
                        }
                    });
            }

            $("[date-picker]").datepicker({ autoclose: true, format: "yyyy-M-dd" })
                .on('keypress', function (e) { return false; })
                .on('changeDate', function (e) { scope.accbank[e.target.name] = e.target.value; })

            $("#btn-select-bank").click(function () { $("#select-bank").modal(); });
            $("#btn-add").click(addNew);
            $("#btn-save").click(save);
            $("#btn-back").click(function () { showList(); });
        }());
    </script>
}